package org.greenstone.android.tipple.base;

import java.util.Timer;
import java.util.TimerTask;
import android.app.Activity;
import android.content.Context;
import android.location.Criteria;
import android.location.Location;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.Display;
import android.view.KeyEvent;
import android.view.Window;
import android.view.ViewGroup.LayoutParams;
import android.view.WindowManager;

public class ARActivity extends Activity {

	Timer timer;
	TimerTask redrawTask;
	AROverlay arOverlay;
	public static boolean directionss = false;
	ArDirection direction;
	//Context con;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		System.err.println("*** ARActivity::onCreate()");
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);

		timer = new Timer();

		initViews();
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		System.err.println("*** ARActivitly::onDestroy()");
	}

	private void initViews() {
		CameraPreview cameraPreview = new CameraPreview(this);
		arOverlay = new AROverlay(this);
		setContentView(cameraPreview); 
		addContentView(arOverlay, new LayoutParams(LayoutParams.WRAP_CONTENT,
				LayoutParams.WRAP_CONTENT));
		Display display = getWindowManager().getDefaultDisplay();
		direction = new ArDirection(this, display);
		addContentView(direction, new LayoutParams(LayoutParams.WRAP_CONTENT,
				LayoutParams.WRAP_CONTENT));

		directionss = true;
	}

	@Override
	protected void onStart() {
		super.onStart();
		System.err.println("*** ARActivity.onStart()");
	}

	@Override
	protected void onStop() {
		super.onStop();
		System.err.println("*** ARActivity.onStop()");
	}

	@Override
	protected void onResume() {
		super.onResume();
		System.err.println("*** ARActivity::onResume()");

		redrawTask = new TimerTask() {
			@Override
			public void run() {
				arOverlay.postInvalidate();
			}
		};
		timer.schedule(redrawTask, 100, 100);

		SensorFusion.getInstance().addClient("ARActivity");
		LocationFusion.getInstance().addClient("ARActivity");
	}

	@Override
	protected void onPause() {
		super.onPause();
		System.err.println("*** ARActivity::onPause()");

		redrawTask.cancel();

		SensorFusion.getInstance().removeClient("ARActivity");
		LocationFusion.getInstance().removeClient("ARActivity");
	}

	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_MENU) {
			if (LocationFusion.getInstance().lastKnownLocation == null) {
				System.err.println("Can't add location: no GPS");
			} else {
				//Global.locations.add(Global.fixedLocation(LocationFusion.getInstance().lastKnownLocation));
				Global.locations.add(Global.randomLocation(LocationFusion.getInstance().lastKnownLocation));
			}
			return true;
		} else if (keyCode == KeyEvent.KEYCODE_SEARCH) {
			if (LocationFusion.getInstance().lastKnownLocation == null) {
				System.err.println("Can't add location: no GPS");
			} else {
				Global.locations.add(Global.makeTipLocation(LocationFusion.getInstance().lastKnownLocation));
			}
			return true;
		} else if (keyCode == KeyEvent.KEYCODE_BACK) {
			finish();
		}
		return false;
	}
}
