package org.greenstone.android.tipple.base;


import org.mapsforge.core.GeoPoint;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.view.Display;
import android.view.View;


public class ArDirection  extends View  {

 	private final float x;
    private final float y;
    private final float r;
    private static double angle;

    
    private final Paint mBlack = new Paint(Paint.LINEAR_TEXT_FLAG);
    private final Paint mGray = new Paint(Paint.ANTI_ALIAS_FLAG);

    Canvas cox;
    private static double lon;
    private static double lat;
    private static double piLong;
    private static double piLat;
    
    public ArDirection(Context context, Display params){
        super(context);
        mGray.setColor(0xff888888);

        this.r = params.getHeight()/10;
        this.x = params.getWidth() - r- 10;
        this.y = params.getHeight() - r -10;
        this.angle = 0;
    }
    
    protected void onDraw(Canvas canvas){
    	super.onDraw(canvas);
    	this.cox = canvas;

    	float endX = getEndX(angle);
    	float  endY = getEndY(angle);

    	mGray.setStyle(Paint.Style.STROKE);
        canvas.drawCircle(x, y, r, mGray);
        
        canvas.drawLine(x, y, endX, endY, mBlack);

        drawLine(cox, -dircAngle(piLong, piLat, lon, lat)-15, mGray);//
        drawLine(cox, -dircAngle(piLong, piLat, lon, lat)+15, mGray);//
        
        drawNlables(cox);
    }
    
    private void drawNlables(Canvas canvas){

    	float endX = getEndX(0);
    	float endY = getEndY(0);
    	canvas.drawText("N", endX-2, endY, mGray);

    	endX = getEndX(90);
    	endY = getEndY(90);
    	canvas.drawText("E", endX+1, endY, mGray);

    	endX = getEndX(180);
   	 	endY = getEndY(180);
   	 	canvas.drawText("S", endX-2, endY+9, mGray);

   	 	endX = getEndX(270);
	 	endY = getEndY(270);
	 	canvas.drawText("W", endX-10, endY, mGray);
    }
    
    private float getEndX(double angle){
    	angle = (angle-90)* Math.PI/180;
    	return (float) ((x) + (r*Math.cos(angle)));
    }
    private float getEndY(double angle){
    	angle = (angle-90)* Math.PI/180;
    	return (float) ((y) + (r*Math.sin(angle)));
    }
    
    
    
    private float dircAngle(double aLong , double alat , double blong, double blat){
    	alat = Math.toRadians(alat);
        blat = Math.toRadians(blat);
        
        // Calculate Difference
        double longitudeDifference = Math.toRadians(blong - aLong);
        
        // Returns the Sine and the Cosine of the specified angle
        double y = Math.sin(longitudeDifference) * Math.cos(blat);
        double x = Math.cos(alat) * Math.sin(blat) - Math.sin(alat) * Math.cos(blat)
        		* Math.cos(longitudeDifference);
   
        // Return Bearing
        return (float) ((Math.toDegrees(Math.atan2(y, x))+ 360) % 360);
    }
    
    protected void drawLine(Canvas canvas, float angl,Paint paint){

     	float endX = getEndX(angl);
     	float endY = getEndY(angl);
     	canvas.drawLine(x, y, endX, endY, paint);
     }
     public static void setChanges(float ang){
    	 angle = ang;
     }
     
     public static void setGPSchanges(GeoPoint point){
     	lon = point.getLongitude();
     	lat = point.getLatitude();
     }
     public static void setGPSpidouble (GeoPoint place){
    	 piLat = place.getLatitude();
    	 piLong = place.getLongitude();
     }
}