package org.greenstone.android.tipple.base;

import org.greenstone.android.tipple.R;
import org.mapsforge.android.maps.MapView;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.Point;
import android.view.Display;
import android.view.WindowManager;

public class MapViewTipple extends MapView
{
	 protected float currentRotation = 0;
	 Context context;
	 SensorFusion sensor_;
	 
	 public MapViewTipple(Context context, SensorFusion sensorFusion) {
		  super(context);
		  this.context = context;
		  sensor_ = sensorFusion;
	 }
 
	 @Override
	 public void onDraw(Canvas canvas) {
		  WindowManager wm = (WindowManager) context.getSystemService(Context.WINDOW_SERVICE);
		  Display display = wm.getDefaultDisplay();
		  int width = display.getWidth();
		  int height = display.getHeight();
		  Bitmap rotatedArrow;
		  
		  currentRotation = sensor_.getBearingDegrees();
		  
		  canvas.save();
		  super.onDraw(canvas);
		  
		  Bitmap headingArrow = BitmapFactory.decodeResource(getResources(), R.drawable.arrows);
		  Matrix matrix = new Matrix();
		  matrix.postRotate(currentRotation, headingArrow.getWidth()-20, headingArrow.getHeight()-5);
		  rotatedArrow = Bitmap.createBitmap(headingArrow , 0, 0, headingArrow.getWidth(), headingArrow.getHeight(), matrix, true);
		  matrix.setTranslate(20, 20);
		  rotatedArrow = Bitmap.createBitmap(rotatedArrow , 0, 0, rotatedArrow.getWidth(), rotatedArrow.getHeight(), matrix, true);
		  canvas.drawBitmap(rotatedArrow, matrix, new Paint());

		  //canvas.rotate(currentRotation);
		  
		  canvas.restore();
	 }
}